/* The X insult server, by Tyler Montbriand.  This code, such as it is, 
   is free as in free beer.  Do what you want with it. */

#if defined (_LP64) || \
    defined(__alpha) || defined(__alpha__) || \
    defined(__ia64__) || defined(ia64) || \
    defined(__sparc64__) || \
    defined(__s390x__) || \
    (defined(__hppa__) && defined(__LP64__)) || \
    defined(__amd64__) || defined(amd64) || \
    defined(__powerpc64__) || \
    (defined(sgi) && (_MIPS_SZLONG == 64))
#define _XSERVER64
#endif

#if SDL_BYTEORDER == SDL_LIL_ENDIAN
#define X_INITIAL_BYTE "l"
#else
#define X_INITIAL_BYTE "B"
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "qdsdl/qdnet.h"
#include "qdsdl/qdsock.h"
#include "xsdl.h"
#include "xsdlproto.h"

const char *insults[]={
   "GO AWAY, KID.  YOU BOTHER ME."
,  "HOW FOUL AND LOATHSOME IS THINE IMAGE"
,  "HE HEARETH NOT, HE STIRRETH NOT, HE MOVETH NOT, THE APE IS DEAD."
,  "I DO NOT LIKE YOUR LOOK, I PROMISE THEE."
,  "PISS ON YOU."
,  "FUCK THIS, I'M LEAVING."
,  "NEEDLES...   IN...  BRAIN!"
,  "MY NAME IS ULI GULLI, THE SWEDISH SPY."
,  "I COULD SHAKE MY TINY FIST AND SWEAR I WASN'T WRONG, BUT WHAT'S THE SENSE IN ARGUING WHEN YOU'RE MUCH TOO BUSY RETURNING TO THE LAVATORY."
,  "WARNING: BEFORE USING ANY MICROSOFT PRODUCT, MICROSOFT RECOMMENDS THAT YOU HAVE A DOG. HAL DOES NOT LIVE. HAL EXISTS, AND HAL IS A HOUND DOG."
,  "EVERYTHING RIGHT IS WRONG AGAIN, JUST LIKE IN THE TERMINAL IDIOM YOU EXPRESSED."
,  "ONE FOOT IS BOTH THE SAME BECAUSE YOU'RE STUPID YOU'RE ACTING LIKE A WET NOODLE."
,  "COWS FLY LIKE CLOUDS BUT THEY ARE NEVER COMPLETELY SUCCESSFUL."
,  "FUNKY DIVAS ATTEMPT TO ROUND UP CERTAIN SMALL CHILDRENS' TOYS SMATTERED UP WITH TINY RAINMAKER COMPACT DISCS SENT UP AS SPUTNIK WAS SUMMARILY DESTORYED BY THE FACT THAT DUCKS ARE QUITE COOL"
,  "TRENT REZNOR, MILLA JOVOVICH, BRYAN FERRY, DR.KIERSEY, GAVIN FRIDAY, DANIEL KEYS MORAN, ELFQUEST, THE KING JAMES BIBLE... THESE ARE SOME THINGS THAT ARE LONG AND METALLIC."
,  "WITHIN MY PENGUIN LIES A TORRID STORY OF HATE AND LOVE."
,  "I HAVE A FEELING THAT YOUR RESPONSES ARE IN A CHICKEN."
,  "CAN WE SET FIRE TO BELT BUCKLES WITH BANANAS?"
,  "THE RAIN WASHES MEMORIES FROM THE GLANDS OF COWS."
,  "WHY HAVE YOU INTERRUPTED THE PROCESS!?"
,  "CHESS IS A FUN SPORT, WHEN PLAYED WITH SHOT GUNS."
,  "BASEBALL IS FOR PEOPLE WHO SHOULD ALREADY BE FUCKING DEAD DEAD DEAD DEAD DEAD DEAD DEAD DEAD DEAD DEAD DEAD"
,  "THE ANSWER, MY FRIEND, IS BLOWING IN THE WIND\n"
   " THE ANSWER IS 42."
,  "THAT'S TERRIFIC. BUT HOW COME WE NEVER ACT, JUST SIT WATCHING AS OUR WORLD CRUMBLES."
,  "KEN KESEY WROTE \"ONE FLEW OVER THE CENTER OF THE CUCKOLDED LIZARD MAN, WHO STRAYED FROM HIS MISTAKES WHEN HE IS A MADEUP WORD."
,  "HERE'S A JOKE FOR YOU: WHY DID THE CHICKEN TURN AROUND AND AROUND IN CIRCLES. AS I THINK SHE TURNED AROUND; BUT WHY? WHY DID THE CHICKEN CROSS THE ROAD; I THINK SHE TURNED AROUND BUT WHY? WHY DID THE CHICKEN TURN AROUND AND DO SOMETHING ELSE?"
,  "EXTERMINATE THE REDNECKS.  EXTERMINATE THE BOURGEOISIE.  ANARCHY NOW. SOCIAL ORDER IS DEAD.  ANARCHY NOW."
,  NULL};

int main(int argc, char *argv[])
{
  int num_insults=0;
  Uint32 blank=0;
  const char *errstr=NULL;
  xConnSetupPrefix p={0,0,X_PROTOCOL,X_PROTOCOL_REVISION,0};

  qdnet net;

  if(!net.Good())
  {
    fprintf(stderr,"Couldn't initialize\n");
    return(1);
  }

  srand((unsigned int)time(NULL));

  while(insults[num_insults] != NULL) num_insults++;


  qdtcp xconn("0.0.0.0",X_TCP_PORT+99); // Server port on screen 99

  if(xconn.Good())
  {
    TCPsocket acc=NULL;
    xConnClientPrefix clauth;
    fprintf(stderr,"Made server socket\n");

    while(acc==NULL)
    {
      acc=xconn.accept();
      if(acc==NULL)
      {
        SDL_Delay(10);
        continue;
      }

      if(SDLNet_TCP_Recv(acc,&clauth,sizeof(clauth))!=sizeof(clauth))
      {
        fprintf(stderr,"bytes < sizeof(clauth)\n");
        SDLNet_TCP_Close(acc);
        acc=NULL;
        continue;
      }

      fprintf(stderr,"Got connection!\n");
      fprintf(stderr,"\tbyteOrder: %c\n",clauth.byteOrder);
      fprintf(stderr,"\tmajorVersion: %u\n",clauth.majorVersion);
      fprintf(stderr,"\tminorVersion: %u\n",clauth.minorVersion);
      fprintf(stderr,"\tnbytesAuthProto: %u\n",clauth.nbytesAuthProto);
      fprintf(stderr,"\tnbytesAuthString: %u\n",clauth.nbytesAuthString);

      errstr=insults[rand()%num_insults];
      p.lengthReason=strlen(errstr);
      p.length=p.lengthReason/4;
      if(p.lengthReason%4) p.length++;

      SDLNet_TCP_Send(acc,&p,sizeof(p));
      SDLNet_TCP_Send(acc,(void *)errstr,strlen(errstr));
      if(p.lengthReason%4)
        SDLNet_TCP_Send(acc,&blank,4-(p.lengthReason%4));

      SDLNet_TCP_Close(acc);
      acc=NULL;
    }

  }
  else
  {
    fprintf(stderr,"Couldn't make connection\n");
    return(1);
  }

  return(0);
}
